
.def sreg_save = r17


EEPROM_read:
    sbic    EECR,EEWE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read                 ; nein, nochmal prfen
 
    out     EEARH, XH                   ; Adresse laden
    out     EEARL, XL    
    sbi     EECR, EERE                  ; Lesevorgang aktivieren
    in      r16, EEDR                   ; Daten in CPU Register kopieren
    adiw    XL:XH,1             	    ; Zeiger erhhen	

    ret


EEPROM_rxc:
    push    temp1                        ; temp1 auf dem Stack sichern
    in      temp1,sreg                   ; SREG sicher, muss praktisch in jeder
                                        ; Interruptroutine gemacht werden
    push    temp1
    
    in      temp1, UDR                   ; empfangenes Byte lesen
    rcall   EEPROM_write                ; Byte im EEPROM speichern
    adiw    YL,1                        ; Zeiger erhhen
    cpi     YL,low(EEPROMEND+1)         ; Vergleiche den Y Zeiger
    ldi     temp1,high(EEPROMEND+1)      ; mit der maximalen EEPROM Adresse +1
    cpc     YH,temp1
    brne    int_rxc_1                   ; wenn ungleich, springen
    ldi     YL,low(Daten)               ; wenn gleich, Zeiger zurcksetzen
    ldi     YH,high(Daten)
int_rxc_1:
 
    pop     temp1
    out     sreg,temp1
    pop     temp1                        ; temp1 wiederherstellen
ret



EEPROM_write:
    sbic    EECR, EEWE                  ; prfe ob der letzte Schreibvorgang beendet ist
    rjmp    EEPROM_write                ; wenn nein, nochmal prfen
 
    out     EEARH, YH                   ; Adresse schreiben
    out     EEARL, YL                   ; 
    out     EEDR,temp1                   ; Daten  schreiben
    in      sreg_save,sreg              ; SREG sichern
    cli                                 ; Interrupts sperren, die nchsten
                                        ; zwei Befehle drfen NICHT
                                        ; unterbrochen werden
    sbi     EECR,EEMWE                  ; Schreiben vorbereiten
    sbi     EECR,EEWE                   ; Und los !
    out     sreg, sreg_save             ; SREG wieder herstellen
    ret
